#!/usr/bin/env ruby
# rcom hosinokaiwa
# html(list) from txt(\t-csv)
#

require 'kconv'

#----- def argopt -----
def argopt ( argv, opt2v )
  argopt0 = []
  argopt1 = []
  argopt2 = []
  num = '0123456789'

  flag = false
  argv.each { |arg|
    if (arg =~ /^-/) && ((arg[1] < num[0]) || (arg[1] > num[-1])) then
      flag = false
      opt2v.each { |opt|
        flag = true if arg == opt
      }
      if flag == false then
        argopt1 << arg
      else
        argopt2 << arg
      end
    else
      if flag == false then
        argopt0 << arg
      else
        argopt2 << arg
      end
      flag = false
    end
  }
  newargopt2 = []
  0.upto(argopt2.size - 2) { |i|
    tmp = []
    tmp << argopt2[i]
    if argopt2[i+1] !~ /^-/
      tmp << argopt2[i+1]
      i = i + 1
    end
    newargopt2 << tmp
  }
  if argopt2[argopt2.size - 1] =~ /^-/
    newargopt2 << argopt2[argopt2.size - 1]
  end
  
  argopts = []
  argopts << argopt0 << argopt1 << newargopt2

  return argopts
end

#----- check arg -----
usage = 'command (input; booklist.txt, reviewlist.txt reviewerlist.txt) (output; list.html?)'
opt2v = []
argopts = argopt ( ARGV, opt2v )
argopts[1].each { |option|
  if (option == "-h") || (option == "-help") then
    $stderr.puts "Usage: " << usage
    exit 1
  end
}

#----- read -----
booklist = open("booklist.txt").readlines.collect! { |line| line = line.kconv(2).chomp.split("\t") }
booklist.pop if booklist[-1].size == 1
booklist.collect! { |line|
  line[-1] = line[-1].to_i
  line
}
reviewlist = open("reviewlist.txt").readlines.collect! { |line| line = line.kconv(2).chomp.split("\t") }
reviewlist.pop if reviewlist[-1].size == 1
reviewlist.collect!{ |line|
  while line.size < 4
    line << ''
  end
  line
}

reviewerlist = open("reviewerlist.txt").readlines.collect! { |line| line.kconv(2).chomp.split("\t") }
reviewerlist.pop if reviewerlist[-1].size == 1

#urlcode˽
book = {}
booklist.each{ |line| book[line[3]] = line }

#urlcode˽
review = {}
reviewlist.each{ |line| 
  review[line[0]] = [] if review[line[0]].nil?
  review[line[0]] << line
}

#shortnamecode˽
reviewer = {}
reviewerlist.each{ |line| reviewer[line[0]] = line }

#shortnamecode˽
review2 = {}
reviewlist.each{ |line| 
  review2[line[2]] = [] if review2[line[2]].nil?
  review2[line[2]] << line
}

#----- count -----
booklist.collect{ |line|
  num = line[-1]
  size = 0
  key = line[3]
  if !review[key].nil?
    size = 1
    if review[key].size > 1
      tmp = []
      0.upto(review[key].size - 2) { |i|
#p review[key][i]
#p review[key][i+1]
        if (review[key][i][2] == review[key][i+1][2]) && (review[key][i][3].gsub(/\[.+\]/,'') == review[key][i+1][3].gsub(/\[.+\]/,''))
        else
          tmp << review[key][i]
        end
      }
      size = tmp.size + 1
    end
  end

  if (size != num) && (num != -1)
    $stderr.puts key + " " + size.to_s + " " + num.to_s
    $stderr.puts "WAR; review-size-error."
#    size = num
     line[-1] = size
     line[-2] = size.to_s
#    exit
  end
#  line << num
}

#----- output -----
def output_booktable( fp, booklist, reviewlist, review, reviewer, option=nil )
  booklist.sort!{ |x,y| (x[-1] <=> y[-1]).nonzero? || (x[-2] <=> y[-2]).nonzero? || (x[0] <=> y[0]).nonzero? || (x[1] <=> y[1]).nonzero? || x[2] <=> y[2]}

  fp.puts '<hr>'
  fp.puts '<p>'
  fp.puts '<a name="book" href="#book"></a>'
  fp.puts '<div align="right">'
  fp.puts '' + booklist.size.to_s + '<br>'
  fp.puts 'ɾ' + review.size.to_s + '<br>'
  fp.puts 'ɾ' + reviewlist.size.to_s + 'ɾ<br>'
  fp.puts '</div>'

  max = 100
  count = max
  flag_init = true
  booklist.reverse.each{ |line|
    if count == max
      if flag_init == false
        fp.puts '</table>'
      end
      flag_init = false
      fp.puts '<table border="1">'
#      fp.puts '<table border="1" width="100%">'
      label = ['ɾ','ֹ','ȥ','']
      label << 'ɾ' if !option.nil?
      fp.puts '<tr><td>' + label.join('</td><td>').gsub(/>ֹ/,' nowrap>ֹ') + '</td></tr>'
    end
    count = count - 1
    count = max if count <= 0

    title = line[4]
    title = '<a href="' + line[3] + '">' + line[4] + '</a>' if line[3].size > 0
    code = line[2]
    code = code.gsub(/,/,'<br>') + '<br>' if !code.nil?
    row = [ line[-2], code, title, line[5] ]

    if !option.nil?
      list = []
      if !review[line[3]].nil?
        review[line[3]].each { |line2|
          list << [ line2[1], line2[2] ]
          list << [ reviewer[line2[2]][2], '.' ]
        }
      end
      str = []
      list.each { |line2|
        str << '<a href="' + line2[0] + '">' + line2[1] + '</a>'
      }
      str = str.join(" ")
      row << str
    end

    fp.puts '<tr><td>' + row.join('</td><td>') + '</td></tr>'
  }
  fp.puts '</table>'
  fp.puts '</p>'
  fp.puts '<hr>'
end

def output_reviewertable( fp, book, reviewer, review2, option=nil )
  review3 = []
  review2.keys.each { |key|
    review3 << [key, review2[key].size]
  }
  review3.sort!{ |x,y| (x[1] <=> y[1]).nonzero? || x[0] <=> y[0] }

  fp.puts '<hr>'
  fp.puts '<a name="reviewer" href="#reviewer"></a>'
  fp.puts '<p>'
  fp.puts '<div align="right">'
  fp.puts 'ɾԿ' + review3.size.to_s + '<br>'
  fp.puts '</div>'

  max = 100
  count = max
  flag_init = true
  review3.reverse.each{ |line|
    if count == max
      if flag_init == false
        fp.puts '</table>'
      end
      flag_init = false
      fp.puts '<table border="1">'
#      fp.puts '<table border="1" width="100%">'
      label = ['ɾ','ɾ']
      label << 'ɾ' if !option.nil?
      fp.puts '<tr><td>' + label.join('</td><td>').gsub(/>ɾ/,' nowrap>ɾ') + '</td></tr>'
    end
    count = count - 1
    count = max if count <= 0

    title = '<a href="' + reviewer[line[0]][2] + '">' + reviewer[line[0]][1] + '</a> '
    row = [ line[-1], title ]

    if !option.nil?
      list = []
      if line[-1] > 0
        review2[line[0]].each { |line2|
          list << [ line2[1], book[line2[0]][2] ]
        }
      end
      str = []
      list.each { |line2|
        str << '<a href="' + line2[0] + '">' + line2[1] + '</a>'
      }
      str = str.join(" ")
      row << str
    end

    fp.puts '<tr><td>' + row.join('</td><td>') + '</td></tr>'
  }
  fp.puts '</table>'
  fp.puts '</p>'
  fp.puts '<hr>'
end

def output_head( file )
  fp = open(file,"w")
  fp.puts '<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">'
  fp.puts '<html lang="ja">'
  fp.puts '<head>'
  fp.puts '<title>DOKUSHO-KYOUDOU-TAI reading ranking + review</title>'
  fp.puts '<link rev="made" href="mailto:ippo@geocities.co.jp">'
  fp.puts '<meta http-equiv="Content-Type" content="text/html;charset=euc-jp">'
  fp.puts '</head>'
  fp.puts '<body bgcolor="#ccffcc" text="#003399" link="#3333ff" vlink="#993333" alink="#ff0000">'
  return fp
end

def output_tail( fp )
  fp.puts '<hr>'
  fp.puts '<div align="right">'
  fp.puts '<a href="index.html"></a>'
  fp.puts '</div>'
  fp.puts '<hr>'
  fp.puts '</body>'
  fp.puts '</html>'
  fp.close if fp != $stdout
end

#----- -----

fp = output_head("list1.html")
fp.puts '<hr>'
fp.puts '<h1>ɽƱΡ<a href="http://homepage1.nifty.com/mai_u/r_com/index.htm">β</a>׽ɾ󥭥</h1>'
fp.puts '<p>'
fp.puts 'βáפΥǡɽɾۿɽ¤٤ΤǤ<br>'
fp.puts 'ɾ󥭥' + ' <a href="list1.html">ʳɾա</a>' + ' <a href="list2.html">ʥ̵</a><br>'
fp.puts 'ʥɡˡࡦ٥' + ' <a href="list3.html">ʳɾա</a>' + ' <a href="list4.html">ʥ̵</a><br>'
fp.puts '</p>'
fp.puts '<div align="right">'
fp.puts 'ɽƱλۿ <a href="http://homepage1.nifty.com/mai_u/index.htm"> </a>  ǧǧ<br>'
fp.puts 'ǽ' + Time.now.to_s + '<br>'
  fp.puts '</div>'
fp.puts '<hr>'
output_booktable( fp, booklist, reviewlist, review, reviewer, true )
output_reviewertable( fp, book, reviewer, review2, true )
fp.puts '[<a href="http://homepage1.nifty.com/mai_u/r_com/hq.htm">ɽƱ</a>]<br>'
output_tail(fp)


fp = output_head("list2.html")
fp.puts '<hr>'
fp.puts '<h1>ɽƱΡ<a href="http://homepage1.nifty.com/mai_u/r_com/index.htm">β</a>׽ɾ󥭥</h1>'
fp.puts '<p>'
fp.puts 'βáפΥǡɽɾۿɽ¤٤ΤǤ<br>'
fp.puts 'ɾ󥭥' + ' <a href="list1.html">ʳɾա</a>' + ' <a href="list2.html">ʥ̵</a><br>'
fp.puts 'ʥɡˡࡦ٥' + ' <a href="list3.html">ʳɾա</a>' + ' <a href="list4.html">ʥ̵</a><br>'
fp.puts '</p>'
fp.puts '<div align="right">'
fp.puts 'ɽƱλۿ <a href="http://homepage1.nifty.com/mai_u/index.htm"> </a>  ǧǧ<br>'
fp.puts 'ǽ' + Time.now.to_s + '<br>'
fp.puts '</div>'
fp.puts '<hr>'
output_booktable( fp, booklist, reviewlist, review, reviewer )
output_reviewertable( fp, book, reviewer, review2 )
fp.puts '[<a href="http://homepage1.nifty.com/mai_u/r_com/hq.htm">ɽƱ</a>]<br>'
output_tail(fp)


newbooklist = []
booklist.each { |line|
  newbooklist << line if (line[1].gsub(/-/,'').to_i < 2000) && (line[-1] >= 3)
}
newreview = {}
newbooklist.each { |line|
  name = line[3]
  newreview[name] = review[name] if !review[name].nil?
}
newreviewlist = []
newreview.each{ |key,value|
  value.each { |line|
    newreviewlist << line
  }
}
newreviewlist.uniq!
newreviewlist.sort!


fp = output_head("list3.html")
fp.puts '<hr>'
fp.puts '<h1>ɽƱΡ<a href="http://homepage1.nifty.com/mai_u/r_com/index.htm">β</a>ץʥɡˡࡦ٥</h1>'
fp.puts 'ɾ󥭥󥰡1999ǯǡɾ3ʾ<br>'
fp.puts '<p>'
fp.puts 'βáפΥǡˡ֣ӣƥ٥ȡפǧƤߤãΥꥹȤǤ
<br>'
fp.puts '3ǯʾ(1999ǯ)˽Ǥǽɾ3İʾ夢ΡȤΤ;Ǥ<br>'
fp.puts 'ɾ󥭥' + ' <a href="list1.html">ʳɾա</a>' + ' <a href="list2.html">ʥ̵</a><br>'
fp.puts 'ʥɡˡࡦ٥' + ' <a href="list3.html">ʳɾա</a>' + ' <a href="list4.html">ʥ̵</a><br>'
fp.puts '</p>'
fp.puts '<div align="right">'
fp.puts 'ɽƱλۿ <a href="http://homepage1.nifty.com/mai_u/index.htm"> </a>  ǧǧ<br>'
fp.puts 'ǽ' + Time.now.to_s + '<br>'
  fp.puts '</div>'
fp.puts '<hr>'
output_booktable( fp, newbooklist, newreviewlist, newreview, reviewer, true )
fp.puts '[<a href="http://homepage1.nifty.com/mai_u/r_com/hq.htm">ɽƱ</a>]<br>'
output_tail(fp)

fp = output_head("list4.html")
fp.puts '<hr>'
fp.puts '<h1>ɽƱΡ<a href="http://homepage1.nifty.com/mai_u/r_com/index.htm">β</a>ץʥɡˡࡦ٥</h1>'
fp.puts 'ɾ󥭥󥰡1999ǯǡɾ3ʾ<br>'
fp.puts '<p>'
fp.puts 'βáפΥǡˡ֣ӣƥ٥ȡפǧƤߤãΥꥹȤǤ
<br>'
fp.puts '3ǯʾ(1999ǯ)˽Ǥǽɾ3İʾ夢ΡȤΤ;Ǥ<br>'
fp.puts 'ɾ󥭥' + ' <a href="list1.html">ʳɾա</a>' + ' <a href="list2.html">ʥ̵</a><br>'
fp.puts 'ʥɡˡࡦ٥' + ' <a href="list3.html">ʳɾա</a>' + ' <a href="list4.html">ʥ̵</a><br>'
fp.puts '</p>'
fp.puts '<div align="right">'
fp.puts 'ɽƱλۿ <a href="http://homepage1.nifty.com/mai_u/index.htm"> </a>  ǧǧ<br>'
fp.puts 'ǽ' + Time.now.to_s + '<br>'
  fp.puts '</div>'
fp.puts '<hr>'
output_booktable( fp, newbooklist, newreviewlist, newreview, reviewer)
fp.puts '[<a href="http://homepage1.nifty.com/mai_u/r_com/hq.htm">ɽƱ</a>]<br>'
output_tail(fp)
