#!/usr/bin/env ruby
# rcom hosinokaiwa
# html(list) from txt(\t-csv)
#

require 'kconv'

#----- def argopt -----
def argopt ( argv, opt2v )
  argopt0 = []
  argopt1 = []
  argopt2 = []
  num = '0123456789'

  flag = false
  argv.each { |arg|
    if (arg =~ /^-/) && ((arg[1] < num[0]) || (arg[1] > num[-1])) then
      flag = false
      opt2v.each { |opt|
        flag = true if arg == opt
      }
      if flag == false then
        argopt1 << arg
      else
        argopt2 << arg
      end
    else
      if flag == false then
        argopt0 << arg
      else
        argopt2 << arg
      end
      flag = false
    end
  }
  newargopt2 = []
  0.upto(argopt2.size - 2) { |i|
    tmp = []
    tmp << argopt2[i]
    if argopt2[i+1] !~ /^-/
      tmp << argopt2[i+1]
      i = i + 1
    end
    newargopt2 << tmp
  }
  if argopt2[argopt2.size - 1] =~ /^-/
    newargopt2 << argopt2[argopt2.size - 1]
  end
  
  argopts = []
  argopts << argopt0 << argopt1 << newargopt2

  return argopts
end

#----- check arg -----
usage = 'command (input; booklist.txt, reviewlist.txt reviewerlist.txt) (output; list.html?)'
opt2v = []
argopts = argopt ( ARGV, opt2v )
argopts[1].each { |option|
  if (option == "-h") || (option == "-help") then
    $stderr.puts "Usage: " << usage
    exit 1
  end
}

#----- read -----
booklist = open("booklist.txt").readlines.collect! { |line| line = line.kconv(2).chomp.split("\t") }
booklist.pop if booklist[-1].size == 1
booklist.collect! { |line|
  line[-1] = line[-1].to_i
  line
}
reviewlist = open("reviewlist.txt").readlines.collect! { |line| line = line.kconv(2).chomp.split("\t") }
reviewlist.pop if reviewlist[-1].size == 1
reviewlist.collect!{ |line|
  while line.size < 4
    line << ''
  end
  line
}

reviewerlist = open("reviewerlist.txt").readlines.collect! { |line| line.kconv(2).chomp.split("\t") }
reviewerlist.pop if reviewerlist[-1].size == 1

#urlcode˽
book = {}
booklist.each{ |line| book[line[3]] = line }

#urlcode˽
review = {}
reviewlist.each{ |line| 
  review[line[0]] = [] if review[line[0]].nil?
  review[line[0]] << line
}

#shortnamecode˽
reviewer = {}
reviewerlist.each{ |line| reviewer[line[0]] = line }

#shortnamecode˽
review2 = {}
reviewlist.each{ |line| 
  review2[line[2]] = [] if review2[line[2]].nil?
  review2[line[2]] << line
}

#----- count -----
booklist.collect{ |line|
  num = line[-1]
  size = 0
  key = line[3]
  if !review[key].nil?
    size = 1
    if review[key].size > 1
      tmp = []
      0.upto(review[key].size - 2) { |i|
#p review[key][i]
#p review[key][i+1]
        if (review[key][i][2] == review[key][i+1][2]) && (review[key][i][3].gsub(/\[.+\]/,'') == review[key][i+1][3].gsub(/\[.+\]/,''))
        else
          tmp << review[key][i]
        end
      }
      size = tmp.size + 1
    end
  end

  if (size != num) && (num != -1)
    $stderr.puts key + " " + size.to_s + " " + num.to_s
    $stderr.puts "WAR; review-size-error."
#    size = num
     line[-1] = size
     line[-2] = size.to_s
#    exit
  end
#  line << num
}

#----- output -----
def output_booktable( fp, booklist, reviewlist, review, reviewer, option=nil )
  booklist.sort!{ |x,y| (x[-1] <=> y[-1]).nonzero? || (x[-2] <=> y[-2]).nonzero? || (x[0] <=> y[0]).nonzero? || (x[1] <=> y[1]).nonzero? || x[2] <=> y[2]}

  fp.puts '<hr>'
  fp.puts '<p>'
  fp.puts '<a name="book" href="#book"></a>'
  fp.puts '<div align="right">'
  fp.puts '' + booklist.size.to_s + '<br>'
  fp.puts 'ɾ' + review.size.to_s + '<br>'
  fp.puts 'ɾ' + reviewlist.size.to_s + 'ɾ<br>'
  fp.puts '</div>'

  max = 100
  count = max
  flag_init = true
  booklist.reverse.each{ |line|
    if count == max
      if flag_init == false
        fp.puts '</table>'
      end
      flag_init = false
      fp.puts '<table border="1">'
#      fp.puts '<table border="1" width="100%">'
      label = ['ɾ','ֹ','ȥ','']
      label << 'ɾ' if !option.nil?
      fp.puts '<tr><td>' + label.join('</td><td>').gsub(/>ֹ/,' nowrap>ֹ') + '</td></tr>'
    end
    count = count - 1
    count = max if count <= 0

    title = line[4]
    title = '<a href="' + line[3] + '">' + line[4] + '</a>' if line[3].size > 0
    code = line[2]
    code = code.gsub(/,/,'<br>') + '<br>' if !code.nil?
    row = [ line[-2], code, title, line[5] ]

    if !option.nil?
      list = []
      if !review[line[3]].nil?
        review[line[3]].each { |line2|
          list << [ line2[1], line2[2] ]
          list << [ reviewer[line2[2]][2], '.' ]
        }
      end
      str = []
      list.each { |line2|
        str << '<a href="' + line2[0] + '">' + line2[1] + '</a>'
      }
      str = str.join(" ")
      row << str
    end

    fp.puts '<tr><td>' + row.join('</td><td>') + '</td></tr>'
  }
  fp.puts '</table>'
  fp.puts '</p>'
  fp.puts '<hr>'
end

def output_reviewertable( fp, book, reviewer, review2, option=nil )
  review3 = []
  review2.keys.each { |key|
    review3 << [key, review2[key].size]
  }
  review3.sort!{ |x,y| (x[1] <=> y[1]).nonzero? || x[0] <=> y[0] }

  fp.puts '<hr>'
  fp.puts '<a name="reviewer" href="#reviewer"></a>'
  fp.puts '<p>'
  fp.puts '<div align="right">'
  fp.puts 'ɾԿ' + review3.size.to_s + '<br>'
  fp.puts '</div>'

  max = 100
  count = max
  flag_init = true
  review3.reverse.each{ |line|
    if count == max
      if flag_init == false
        fp.puts '</table>'
      end
      flag_init = false
      fp.puts '<table border="1">'
#      fp.puts '<table border="1" width="100%">'
      label = ['ɾ','ɾ']
      label << 'ɾ' if !option.nil?
      fp.puts '<tr><td>' + label.join('</td><td>').gsub(/>ɾ/,' nowrap>ɾ') + '</td></tr>'
    end
    count = count - 1
    count = max if count <= 0

    title = '<a href="' + reviewer[line[0]][2] + '">' + reviewer[line[0]][1] + '</a> '
    row = [ line[-1], title ]

    if !option.nil?
      list = []
      if line[-1] > 0
        review2[line[0]].each { |line2|
          list << [ line2[1], book[line2[0]][2] ]
        }
      end
      str = []
      list.each { |line2|
        str << '<a href="' + line2[0] + '">' + line2[1] + '</a>'
      }
      str = str.join(" ")
      row << str
    end

    fp.puts '<tr><td>' + row.join('</td><td>') + '</td></tr>'
  }
  fp.puts '</table>'
  fp.puts '</p>'
  fp.puts '<hr>'
end

def output_head( file, target = nil )
  fp = open(file,"w")
  fp.puts '<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">'
  fp.puts '<html lang="ja">'
  fp.puts '<head>'
  fp.puts '<title>DOKUSHO-KYOUDOU-TAI reading ranking + review</title>'
  fp.puts '<link rev="made" href="mailto:ippo@geocities.co.jp">'
  fp.puts '<meta http-equiv="Content-Type" content="text/html;charset=euc-jp">'
  if !target.nil?
    fp.puts '<base target="' + target + '">'
  end
  fp.puts '</head>'
  fp.puts '<body bgcolor="#ccffcc" text="#003399" link="#3333ff" vlink="#993333" alink="#ff0000">'
  return fp
end

def output_tail( fp )
  fp.puts '<hr>'
  fp.puts '<div align="right">'
  fp.puts '<a href="index.html"></a>'
  fp.puts '</div>'
  fp.puts '<hr>'
  fp.puts '</body>'
  fp.puts '</html>'
  fp.close if fp != $stdout
end

#----- -----
filelist = []
booklist.each{ |line|
  file = line[3].gsub(/^.+?\/([^\/]+?)$/){$1}
  flie = File.basename(file)
  filelist << file
}
filelist.uniq!
filelist.delete("")
filelist.sort!

fp = $stdout
convlist = {}
count = 0
count_file = 1
filelist.each{ |file|
  base = 'check_' + count_file.to_s + '.html'
  tag = File.basename(file, ".htm")
  tag = tag.gsub(/\.(.+?)$/,'')
  url = base + '#' + tag
  convlist[file] = url

  if count == 0
    fp = output_head(base)
  end
  
  $stderr.puts "CHK; " + file
  data = open(tag + '.txt').read.kconv(2).split("\n\n")
  fp.puts '<hr>'
  fp.puts '<a name="' + tag + '" href="#' + tag + '"></a><br>'
  fp.puts '<strong>'
  data[0].split("\n").each { |line|
    fp.puts line + '<br>'
  }
  fp.puts '</strong>'
  data[1].split("\n").each { |line|
    line2 = line.split("\t")
      fp.puts '<a href="' + line2[0] + '" target="_blank">' + line2[1] + '</a>'
      fp.puts line2[3] if !line2[3].nil?
      fp.puts '<a href="' + line2[2] + '" target="_blank">H</a>'
      fp.puts '<br>'
  }
  str = ''
  data[2].split("\n").each { |line|
    str << '<img src="' + line + '">'
  }
  fp.puts str + '<br>'

  count = count + 1
  if count == 100
    output_tail(fp)
    count = 0
    count_file = count_file + 1
  end
}

#----- -----
str_zen = ["","","","","","","","","","","","",""]
str_han = ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", '\*', '\+', '\-']
str_pub = ["ϥ䥫ӣʸ","ϸӣʸˡϸʸ","˼ñ","˼ϥ䥫ӣƥ꡼","˼˥롦ʸ"]
str_key = ["hb","sb","hh","hs","hdk"]

fp = output_head("check_0.html", "a")

publish, year = '', ''
code1, code2 = '',''
booklist.each {|line|
  if publish != line[0]
    publish = line[0]
    code1 = line[0]
    str_pub.each_index{ |j|
      code1 = str_key[j] if code1 == str_pub[j]
    }
    code2 = 'all'
    code = code1 + '_' + code2
    fp.puts '<p><strong><a name="' + code + '" href="#' + code + '" target="f"></a>' + publish + '</strong></p>'
  end
  if year != line[1]
    year = line[1]
    code2 = year.gsub(/-/,'')
    code = code1 + '_' + code2
    fp.puts '<p><strong><a name="' + code + '" href="#' + code + '" target="f"></a>' + year + '</strong></p>'
  end

  file = line[3].gsub(/^.+?\/([^\/]+?)$/){$1}
  flie = File.basename(file)
  num  = line[-2]
  str_han.each_index{ |j|
    num.gsub!(/#{str_han[j]}/,str_zen[j])
  }
  num = '' + num + ''
  title = line[4]
  option = ''
  if title =~/^(.+)(.+?)$/
    title, option = $1, $2
  end
  if !convlist[file].nil?
    title = '<a href="' + convlist[file] + '">' + title + '</a>' + option
  else
    title << option
  end
  list = [line[2], title, line[5], num]
  fp.puts list.join("") + '<br>'
}

output_tail(fp)


fp = open("check_frame.html", "w")
fp.puts '<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">'
fp.puts '<html lang="ja">'
fp.puts '<head>'
fp.puts '<title>DOKUSHO-KYOUDOU-TAI reading ranking + review</title>'
fp.puts '<link rev="made" href="mailto:ippo@geocities.co.jp">'
fp.puts '<meta http-equiv="Content-Type" content="text/html;charset=euc-jp">'
fp.puts '</head>'
fp.puts '<frameset cols="*,160">'
fp.puts '<frame src="check_0.html" name="f" marginheight="10" marginwidth="10">'
fp.puts '<frame                    name="a" marginheight="10" marginwidth="2">'
fp.puts '</frameset>'
fp.puts '<noframe>'
fp.puts '<a href="check_0.html"></a>'
fp.puts '</noframe>'
fp.puts '</html>'
